<?php
// $Id: table_check.php,v 1.1.1.1 2005/02/16 17:32:30 ohwada Exp $

//================================================================
// check table validation
// 2005-01-20 K.OHWADA
//================================================================

include '../../../mainfile.php';
include '../../../include/cp_header.php';

global $xoopsDB, $xoopsUser, $xoopsModule;
xoops_cp_header();

echo "<h3>check table adjustment</h3>\n";

// check permission
$flag = false;
if ($xoopsUser && $xoopsUser->isAdmin($xoopsModule->mid())) 
{	$flag = true;	}

if (!$flag)
{
	echo "<font color='red'>you are not admin</font><br>";
	xoops_cp_footer();
	exit();
}

$op = 'main';
if ( isset($_POST['op']) )  $op = $_POST['op'];

// dir name
$MODULE_DIRNAME = $xoopsModule->dirname();
$MODULE_ROOT    = XOOPS_ROOT_PATH."/modules/".$MODULE_DIRNAME;
$MODULE_URL     = XOOPS_URL."/modules/".$MODULE_DIRNAME;

// table name
$table_link     = $xoopsDB->prefix( $MODULE_DIRNAME."_link" );
$table_category = $xoopsDB->prefix( $MODULE_DIRNAME."_category" );
$table_catlink  = $xoopsDB->prefix( $MODULE_DIRNAME."_catlink" );

switch ($op) 
{
case "correct_catlink_zombie_link":
	correct_catlink_zombie_link();
	break;

case "correct_catlink_zombie_category":
	correct_catlink_zombie_category();
	break;

case 'main':
default:
	check();
	break;

}

xoops_cp_footer();
exit();



function check()
{
	global $xoopsDB;
	global $table_link, $table_category, $table_catlink;

	$sql1 = "SELECT lid FROM $table_link ORDER BY lid";
	$lid_arr_1 = sql_first_row($sql1);

	$sql2 = "SELECT DISTINCT lid FROM $table_catlink ORDER BY lid";
	$lid_arr_2 = sql_first_row($sql2);

// check zombie link
	$lid_arr_3 = check_in_array($lid_arr_1, $lid_arr_2);
	if ( count($lid_arr_3) )
	{
		print_form_catlink_zombie_link($lid_arr_3);
		return;
	}

// check link without category
	$lid_arr_4 = check_in_array($lid_arr_2, $lid_arr_1);
	if ( count($lid_arr_4) )
	{
		print_link_without_category($lid_arr_4);
		return;
	}

	$sql3 = "SELECT cid FROM $table_category ORDER BY cid";
	$cid_arr_1 = sql_first_row($sql3);

	$sql4 = "SELECT DISTINCT cid FROM $table_catlink ORDER BY cid";
	$cid_arr_2 = sql_first_row($sql4);

// check zombie category
	$cid_arr_3 = check_in_array($cid_arr_1, $cid_arr_2);
	if ( count($cid_arr_3) )
	{
		print_form_catlink_zombie_category($cid_arr_3);
		return;
	}

// check link without category
	$cid_arr_4 = check_in_array($cid_arr_2, $cid_arr_1);
	if ( count($cid_arr_4) )
	{
		print_category_without_link($cid_arr_4);
	}

	echo "<h4>check OK</h4>\n";
	echo "<a href='index.php'>GOTO Admin Menu</a><br>\n";

}

function check_in_array($arr_1, $arr_2)
{
	$arr_3 = array();

	foreach ($arr_2 as $id)
	{
		if ( !in_array($id, $arr_1) )
		{
			$arr_3[] = $id;
		}
	}

	return $arr_3;
}

function print_form_catlink_zombie_link($lid_arr)
{
	$count  = count($lid_arr);
	$action = xoops_getenv('PHP_SELF');

?>
<br>
<hr>
<h4><font color='red'>ERROR</font></h4>
There are <b><?php echo $count; ?></b> zombie links in catlink table <br>
<br>
<form action='<?php echo $action; ?>' method='post'>
<input type='hidden' name='op' value='correct_catlink_zombie_link'>
<?php

	foreach($lid_arr as $lid)
	{
		echo "<input type='hidden' name='lid[]' value='$lid'>";
		echo "lid: $lid <br>\n";
	}

	echo "<br>\n";

?>
<input type='submit' value='CORRECT'>
</form>
<?php

}

function correct_catlink_zombie_link()
{
	global $xoopsDB;
	global $table_catlink;

	echo "<h4>correct catlink table</h4>\n";
	echo "delete link form catlink table <br><br>\n";

	$lid_arr = array();
	if ( isset($_POST['lid']) )  $lid_arr = $_POST['lid'];

	foreach ($lid_arr as $lid)
	{
		echo "lid: $lid <br>\n";
		$sql = "DELETE FROM $table_catlink WHERE lid=$lid";
		sql_exec($sql);
	}

	echo "<br><hr>\n";
	echo "<h4>FINISHED</h4>\n";
	echo "<a href='index.php'>GOTO Admin Menu</a><br>\n";

}


function print_link_without_category($lid_arr)
{
	global $xoopsDB;
	global $MODULE_URL;
	global $table_link;

	$count  = count($lid_arr);

?>
<br>
<hr>
<h4><font color='red'>ERROR</font></h4>
There are <b><?php echo $count; ?></b> links without category in link table <br>
<br>
<table border='1'><tr>
<th>link id</th>
<th>title</th>
</tr>
<?php

	foreach($lid_arr as $lid)
	{
		$sql = "SELECT lid, title FROM $table_link WHERE lid=$lid";
		$res = sql_exec($sql);
		$row = $xoopsDB->fetchRow($res);

		$lid   = $row[0];
		$title = $row[1];

		$link_id = sprintf("%03d", $lid);
		$modlink = $MODULE_URL."/admin/link_manage.php?op=modLink&lid=".$lid;
		$title   = htmlspecialchars($title);

		echo "<tr>";
		echo "<td><a href='$modlink'>$link_id</a>";
		echo "<td>$title</td>";
		echo "</tr>\n";
	}

?>
</table>
<?php

}

function print_form_catlink_zombie_category($cid_arr)
{
	$count  = count($cid_arr);
	$action = xoops_getenv('PHP_SELF');

?>
<br>
<hr>
<h4><font color='red'>ERROR</font></h4>
There are <b><?php echo $count; ?></b> zombie categories in catlink table <br>
<br>
<form action='<?php echo $action; ?>' method='post'>
<input type='hidden' name='op' value='correct_catlink_zombie_category'>
<?php

	foreach($cid_arr as $cid)
	{
		echo "<input type='hidden' name='cid[]' value='$cid'>";
		echo "cid: $cid <br>\n";
	}

	echo "<br>\n";

?>
<input type='submit' value='CORRECT'>
</form>
<?php

}


function correct_catlink_zombie_category()
{
	global $xoopsDB;
	global $table_catlink;

	echo "<h4>correct catlink table</h4>\n";
	echo "delete category form catlink table <br><br>\n";

	$cid_arr = array();
	if ( isset($_POST['cid']) )  $cid_arr = $_POST['cid'];

	foreach ($cid_arr as $cid)
	{
		echo "cid: $cid <br>\n";
		$sql = "DELETE FROM $table_catlink WHERE cid=$cid";
		sql_exec($sql);
	}

	echo "<br><hr>\n";
	echo "<h4>FINISHED</h4>\n";
	echo "<a href='index.php'>GOTO Admin Menu</a><br>\n";

}

function print_category_without_link($cid_arr)
{
	global $xoopsDB;
	global $MODULE_URL;
	global $table_category;

	$count  = count($cid_arr);

?>
<br>
<hr>
<h4>Notice</h4>
There are <b><?php echo $count; ?></b> categories without link in category table <br>
<br>
<table border='1'><tr>
<th>category id</th>
<th>title</th>
</tr>
<?php

	foreach($cid_arr as $cid)
	{
		$sql = "SELECT cid, title FROM $table_category WHERE cid=$cid";
		$res = sql_exec($sql);
		$row = $xoopsDB->fetchRow($res);

		$cid   = $row[0];
		$title = $row[1];

		$cat_id = sprintf("%03d", $cid);
		$modlink = $MODULE_URL."/admin/catebory_manage.php?op=modCat&cid=".$cid;
		$title   = htmlspecialchars($title);

		echo "<tr>";
		echo "<td><a href='$modlink'>$cat_id</a>";
		echo "<td>$title</td>";
		echo "</tr>\n";
	}

?>
</table>
<?php

}

function sql_first_row($sql)
{
	global $xoopsDB;

	$res = sql_exec($sql);

	$arr = array();

	while ( $row =  $xoopsDB->fetchRow($res) ) 
	{
		$arr[] = $row[0];
	}

	return $arr;
}

function sql_exec($sql)
{ 
	global $xoopsDB;

	$ret = $xoopsDB->queryF($sql);
	if ($ret != false ) { return $ret; }

	$error = $xoopsDB->error();
	echo "<font color='red'>$sql<br>$error</font><br>";

	return false;
}


?>